/*
 * ProFTPD: mod_mysql -- Support for auth and up/download ratios with mysql.
 * Time-stamp: <1999-05-03 02:10:20 root>
 * Copyright (c) 1998-1999 Johnie Ingram.
 *  
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef MOD_MYSQL_H
#define MOD_MYSQL_H

typedef struct {

  int fstor;
  int fretr;
  int bstor;
  int bretr;

  int frate;
  int fcred;
  int brate;
  int bcred;

} modmysql_luser;

/* The struct above and modmysql_getstats() is PROBABLY all any other
   module would need, but just to be on the safe side..... */

extern int  modmysql_connect            (void);
extern int  modmysql_disconnect         (void);

extern int  modmysql_query              (cmd_rec *cmd, const char *query);
extern int  modmysql_queryuser          (cmd_rec *cmd, const char *user,
					 const char *query, int update);
extern int  modmysql_checkpass          (cmd_rec *cmd, const char *user,
					 const char *pass);
extern int  modmysql_getstats           (cmd_rec *cmd, modmysql_luser *stats);
extern int  modmysql_setstats           (cmd_rec *cmd, int fstor, int fretr,
					 int bstor, int bretr);
extern
const char* modmysql_getuservar         (cmd_rec *cmd, const char *user,
					 const char *var);

#endif








